/*
 * JPA DAO Template
 *
 *
 * Takatuka - Template fuer JPA DAO
 *
 */

package de.ivu.elect.business.wahlbeteiligung.boundary;

import javax.persistence.NoResultException;
import javax.persistence.NonUniqueResultException;
import javax.persistence.EntityNotFoundException;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import de.ivu.elect.business.wahlbeteiligung.entity.WahlbeteiligungAuswertung;
import de.ivu.elect.business.wahlbeteiligung.entity.WahlbeteiligungAuswertungUK;

public abstract class AbstractWahlbeteiligungAuswertungDAO extends de.ivu.elect.jee.entity.AbstractDAO<WahlbeteiligungAuswertung,
        de.ivu.elect.business.wahlbeteiligung.entity.WahlbeteiligungAuswertungPK
    , WahlbeteiligungAuswertungUK> {

  private static final long serialVersionUID = 1L;

  private static final Logger LOG = LoggerFactory.getLogger(AbstractWahlbeteiligungAuswertungDAO.class);

  public AbstractWahlbeteiligungAuswertungDAO() {
    super();
  }

  public boolean isEntityWithPKPresent(
            de.ivu.elect.business.wahlbeteiligung.entity.WahlbeteiligungAuswertungPK
     pk) {
    if (pk != null && pk.getId() != null) {
      return findByPrimaryKey(pk) != null;
    }

    return false;
  }

  @Override
  public WahlbeteiligungAuswertung findByPrimaryKey(
        de.ivu.elect.business.wahlbeteiligung.entity.WahlbeteiligungAuswertungPK
      pk) {
    if (pk != null && pk.getId() != null) {
      return findByPrimaryKey(pk.getId());
    }

    throw new IllegalArgumentException("PK oder PK.getId() ist null! [pk = " + pk + "]");
  }


  @Override
  protected WahlbeteiligungAuswertung findByPrimaryKey(Long id) {
    if (id == null) {
      throw new IllegalArgumentException("ID ist null! [id = " + id + "]");
    }
  return getEntityManager().find(WahlbeteiligungAuswertung.class, id, CACHE_PROPERTIES);
  }



     /**
      * Name: TypAndStatusNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT o FROM WahlbeteiligungAuswertung o WHERE o.typ =?1 AND o.status = ?2 ORDER BY o.datum<br>
      * SQL: <br>
      */
     public java.util.List<WahlbeteiligungAuswertung> findByTypAndStatus( @javax.annotation.Nonnull de.ivu.elect.business.wahlbeteiligung.entity.WahlbeteiligungAuswertungTyp typ,  @javax.annotation.Nonnull de.ivu.elect.business.wahlbeteiligung.entity.WahlbeteiligungAuswertungStatus status) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

        int versuch = 0;
      while (true) {
        versuch++;
                try {

          		  			  de.ivu.elect.business.wahlbeteiligung.entity.WahlbeteiligungAuswertungTyp typCheckedAndAttached =  checkAndAttach(typ, de.ivu.elect.business.wahlbeteiligung.entity.WahlbeteiligungAuswertungTyp.class, "typ"); ;
		  			  de.ivu.elect.business.wahlbeteiligung.entity.WahlbeteiligungAuswertungStatus statusCheckedAndAttached =  checkAndAttach(status, de.ivu.elect.business.wahlbeteiligung.entity.WahlbeteiligungAuswertungStatus.class, "status"); ;
		  
                              return
                              getEntityManager().
                                createNamedQuery("WAHLBETEILIGUNG_AUSWERTUNG.TypAndStatus")
                              .setParameter(1, typCheckedAndAttached)
                                        .setParameter(2, statusCheckedAndAttached)
                                                                      .getResultList();
                                        
                    
        } catch (EntityNotFoundException enfe) {
      // ELECTMUC-2455
       if (de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.INVALIDATE_CACHE &&
       versuch < de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.MAX_VERSUCHE ) {
       LOG.warn("findByTypAndStatus - EntityNotFoundException: " +enfe.getMessage()+", Versuch: " +versuch+" - lösche Cache - wiederhole");
        try {
         de.ivu.elect.business.system.boundary.CacheResetSession.reset(getEntityManager());
        } catch (Exception e) {
          LOG.warn("Fehler beim Zurücksetzen des Cache: "+e.getMessage());

        }
       } else {
        throw enfe;
       }
           } catch (NonUniqueResultException nure) {
    LOG.warn("WahlbeteiligungAuswertung, findByTypAndStatus - NonUniqueResultException, Parameter: "
           + ", typ:'"+typ+"'"
           + ", status:'"+status+"'"
    
        );
    throw nure;
            }
            }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByTypAndStatus(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: WahlExistsNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT CASE WHEN (COUNT(o) > 0) THEN TRUE ELSE FALSE END FROM WahlbeteiligungAuswertung o WHERE o.wahl = ?1<br>
      * SQL: <br>
      */
     public java.lang.Boolean findByWahlExists( @javax.annotation.Nonnull de.ivu.elect.business.wahl.entity.Wahl wahl) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

        int versuch = 0;
      while (true) {
        versuch++;
                try {

          		  			  de.ivu.elect.business.wahl.entity.Wahl wahlCheckedAndAttached =  checkAndAttach(wahl, de.ivu.elect.business.wahl.entity.Wahl.class, "wahl"); ;
		  
                              return
                    (java.lang.Boolean)
                              getEntityManager().
                                createNamedQuery("WAHLBETEILIGUNG_AUSWERTUNG.WahlExists")
                              .setParameter(1, wahlCheckedAndAttached)
                                                                      .getSingleResult();
                                        
                    
        } catch (EntityNotFoundException enfe) {
      // ELECTMUC-2455
       if (de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.INVALIDATE_CACHE &&
       versuch < de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.MAX_VERSUCHE ) {
       LOG.warn("findByWahlExists - EntityNotFoundException: " +enfe.getMessage()+", Versuch: " +versuch+" - lösche Cache - wiederhole");
        try {
         de.ivu.elect.business.system.boundary.CacheResetSession.reset(getEntityManager());
        } catch (Exception e) {
          LOG.warn("Fehler beim Zurücksetzen des Cache: "+e.getMessage());

        }
       } else {
        throw enfe;
       }
           } catch (NonUniqueResultException nure) {
    LOG.warn("WahlbeteiligungAuswertung, findByWahlExists - NonUniqueResultException, Parameter: "
           + ", wahl:'"+wahl+"'"
    
        );
    throw nure;
            }
            }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByWahlExists(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: WahlNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT o FROM WahlbeteiligungAuswertung o WHERE o.wahl = ?1<br>
      * SQL: <br>
      */
     public java.util.List<WahlbeteiligungAuswertung> findByWahl( @javax.annotation.Nonnull de.ivu.elect.business.wahl.entity.Wahl wahl) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

        int versuch = 0;
      while (true) {
        versuch++;
                try {

          		  			  de.ivu.elect.business.wahl.entity.Wahl wahlCheckedAndAttached =  checkAndAttach(wahl, de.ivu.elect.business.wahl.entity.Wahl.class, "wahl"); ;
		  
                              return
                              getEntityManager().
                                createNamedQuery("WAHLBETEILIGUNG_AUSWERTUNG.Wahl")
                              .setParameter(1, wahlCheckedAndAttached)
                                                                      .getResultList();
                                        
                    
        } catch (EntityNotFoundException enfe) {
      // ELECTMUC-2455
       if (de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.INVALIDATE_CACHE &&
       versuch < de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.MAX_VERSUCHE ) {
       LOG.warn("findByWahl - EntityNotFoundException: " +enfe.getMessage()+", Versuch: " +versuch+" - lösche Cache - wiederhole");
        try {
         de.ivu.elect.business.system.boundary.CacheResetSession.reset(getEntityManager());
        } catch (Exception e) {
          LOG.warn("Fehler beim Zurücksetzen des Cache: "+e.getMessage());

        }
       } else {
        throw enfe;
       }
           } catch (NonUniqueResultException nure) {
    LOG.warn("WahlbeteiligungAuswertung, findByWahl - NonUniqueResultException, Parameter: "
           + ", wahl:'"+wahl+"'"
    
        );
    throw nure;
            }
            }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByWahl(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }



  @Override
  public boolean isEntityWithUKPresent(de.ivu.elect.business.wahlbeteiligung.entity.WahlbeteiligungAuswertungUK uk) {
    try {
      return findByUK(uk) != null;
    } catch (javax.persistence.NoResultException nre) {
      return false;
    }
  }

  @Override
  public boolean isEntityWithUKHasPK(de.ivu.elect.business.wahlbeteiligung.entity.WahlbeteiligungAuswertungUK uk,
        de.ivu.elect.business.wahlbeteiligung.entity.WahlbeteiligungAuswertungPK
      pk

  ) {
    try {
      return findByUK(uk).getPk().equals(pk);
    } catch (NoResultException ignored) {
      // Do nothing - be happy.
    }
    return true;
  }

   public de.ivu.elect.business.wahlbeteiligung.entity.WahlbeteiligungAuswertung findByUK(de.ivu.elect.business.wahlbeteiligung.entity.WahlbeteiligungAuswertungUK uk){

    try {
     return (de.ivu.elect.business.wahlbeteiligung.entity.WahlbeteiligungAuswertung) getEntityManager().createNamedQuery("WAHLBETEILIGUNG_AUSWERTUNG.UK")
                  .setParameter(1, uk
                .getDatum ()

              )
             .setParameter(2, uk
                .getWahlUK ()

                .getWahlartUK ()

                .getName ()

              )
             .setParameter(3, uk
                .getWahlUK ()

                .getWahlartUK ()

                .getMandantUK ()

                .getNummer ()

              )
             .setParameter(4, uk
                .getWahlUK ()

                .getWahlterminUK ()

                .getNummer ()

              )
             .setParameter(5, uk
                .getWahlUK ()

                .getWahlterminUK ()

                .getWahldatum ()

              )
             .setParameter(6, uk
                .getWahlUK ()

                .getWahlterminUK ()

                .getMandantUK ()

                .getNummer ()

              )
          .getSingleResult()
     ;
     } catch (NonUniqueResultException nure) {
        LOG.warn("WahlbeteiligungAuswertung, findByUK - NonUniqueResultException, UK: " + uk);
        throw nure;
     }
  }
    
}